/**
 * Created by Renat Fazilyanov(cptrnt@mail.ru) on 23.05.18.
 */
'use strict';

Object.defineProperties( Date.prototype, {

    getWeekYear: {
        value: function () {
            // Copy date so don't modify original
            let d = new Date(+this);
            d.setHours(0,0,0,0);
            // Set to nearest Thursday: current date + 4 - current day number
            // Make Sunday's day number 7
            d.setDate(d.getDate() + 4 - (d.getDay()||7));
            // Get first day of year
            let yearStart = new Date(d.getFullYear(),0,1);
            // Calculate full weeks to nearest Thursday
            return Math.ceil(( ( (d - yearStart) / 86400000) + 1)/7);
        },
        enumerable : false,
        writable : true
    },

    dayOffset: {
        value: function ( ms = false ) {

            let startDay = this.toISOString().slice(0,10)+"T00:00:00.001Z";
            startDay = Date.parse( startDay );
            let offset = this - startDay;

            if( !ms ) offset = Math.ceil( offset/1000 );

            return offset;

        },
        enumerable : false,
        writable : true
    },

    keys: {
        value: function () {
            return {
                day: +this.toISOString().slice(0,10).split('-').join(''),
                month: +`${this.toISOString().slice(0,7).split('-').join('')}01`,
                week: +`${this.getFullYear()}00${this.getWeekYear()}`,
            }
        },
        enumerable : false,
        writable : true
    },

    dateComponents: {
        value: function () {
            let keys = this.keys();
            return {
                datetime	: this.toISOString(),
                dayOffset	: this.dayOffset(),
                min			: this.getMinutes(),
                hour		: this.getHours(),
                weekDay		: this.getDay(),

                dateKey		: keys.day,
                monthKey	: +keys.month.toString().slice(0,6),
                weekYear	: this.getWeekYear(),
            }
        },
        enumerable : false,
        writable : true
    },


    toDtString: {
        value: function () {

            let str  = this.toISOString().replace('T',' ').replace('Z','');
            str = str.substr(0, 19);

            return str;
        },
        enumerable : false,
        writable : true
    },

    toDString: {
        value: function () {

            let str  = this.toISOString().substr(0, 10);
            str = str.substr(0, 19);

            return str;
        },
        enumerable : false,
        writable : true
    },


} );
